/***************************************************************************
*
* AutomateIT -- MS Office COM objects cloner
* 
* Copyright (C) 2005 by ApriorIT <support@apriorit.com>
* 
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation; either version 2.1 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
* 
* You should have received a copy of the GNU Lesser General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
****************************************************************************/


#ifndef LOG_H
#define LOG_H

#include <stdlib.h>

#ifdef _DEBUG
#define WRITE_LOG_A(param) CLog::PrintA param
#define WRITE_LOG_W(param) CLog::PrintW param
#else
#define WRITE_LOG_A(param)
#define WRITE_LOG_W(param)
#endif

// Release logs



#define WRITE_LOG_R_A(param) // (CLog::s_bIsLog ? CLog::PrintA param : 0)
#define WRITE_LOG_R_W(param) // (CLog::s_bIsLog ? CLog::PrintW param : 0)

// CLog class provides logging capabilities.

class CLog
{
    static char     s_pszLogFileName[_MAX_PATH];
public:

    /*
        SetFileName method sets name and location of the log file.
    */
    static void SetFileName(char *pszFileName);
    //static void EnableLog(BOOL bIsLog);

    /*
        PrintW method writes log message in ASCII. The message may 
        contains formatting information as specified for the prinf function.
    */
    static CLog::PrintA(const char *fmt, ...);

    /*
        PrintW method writes log message in UNICODE. The message may 
        contains formatting information as specified for the prinf function.
    */    
    static CLog::PrintW(const wchar_t *fmt, ...);   
};

#endif // LOG_H
